// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from clpe_ros_msgs:msg/ClpeCameraInfo.idl
// generated code does not contain a copyright notice
#include "clpe_ros_msgs/msg/detail/clpe_camera_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `production_date`
#include "rosidl_runtime_c/string_functions.h"

bool
clpe_ros_msgs__msg__ClpeCameraInfo__init(clpe_ros_msgs__msg__ClpeCameraInfo * msg)
{
  if (!msg) {
    return false;
  }
  // calibration_model
  // fx
  // fy
  // cx
  // cy
  // k1
  // k2
  // k3
  // k4
  // rms
  // fov
  // calibration_temperature
  // p1
  // p2
  // production_date
  if (!rosidl_runtime_c__String__init(&msg->production_date)) {
    clpe_ros_msgs__msg__ClpeCameraInfo__fini(msg);
    return false;
  }
  return true;
}

void
clpe_ros_msgs__msg__ClpeCameraInfo__fini(clpe_ros_msgs__msg__ClpeCameraInfo * msg)
{
  if (!msg) {
    return;
  }
  // calibration_model
  // fx
  // fy
  // cx
  // cy
  // k1
  // k2
  // k3
  // k4
  // rms
  // fov
  // calibration_temperature
  // p1
  // p2
  // production_date
  rosidl_runtime_c__String__fini(&msg->production_date);
}

bool
clpe_ros_msgs__msg__ClpeCameraInfo__are_equal(const clpe_ros_msgs__msg__ClpeCameraInfo * lhs, const clpe_ros_msgs__msg__ClpeCameraInfo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // calibration_model
  if (lhs->calibration_model != rhs->calibration_model) {
    return false;
  }
  // fx
  if (lhs->fx != rhs->fx) {
    return false;
  }
  // fy
  if (lhs->fy != rhs->fy) {
    return false;
  }
  // cx
  if (lhs->cx != rhs->cx) {
    return false;
  }
  // cy
  if (lhs->cy != rhs->cy) {
    return false;
  }
  // k1
  if (lhs->k1 != rhs->k1) {
    return false;
  }
  // k2
  if (lhs->k2 != rhs->k2) {
    return false;
  }
  // k3
  if (lhs->k3 != rhs->k3) {
    return false;
  }
  // k4
  if (lhs->k4 != rhs->k4) {
    return false;
  }
  // rms
  if (lhs->rms != rhs->rms) {
    return false;
  }
  // fov
  if (lhs->fov != rhs->fov) {
    return false;
  }
  // calibration_temperature
  if (lhs->calibration_temperature != rhs->calibration_temperature) {
    return false;
  }
  // p1
  if (lhs->p1 != rhs->p1) {
    return false;
  }
  // p2
  if (lhs->p2 != rhs->p2) {
    return false;
  }
  // production_date
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->production_date), &(rhs->production_date)))
  {
    return false;
  }
  return true;
}

bool
clpe_ros_msgs__msg__ClpeCameraInfo__copy(
  const clpe_ros_msgs__msg__ClpeCameraInfo * input,
  clpe_ros_msgs__msg__ClpeCameraInfo * output)
{
  if (!input || !output) {
    return false;
  }
  // calibration_model
  output->calibration_model = input->calibration_model;
  // fx
  output->fx = input->fx;
  // fy
  output->fy = input->fy;
  // cx
  output->cx = input->cx;
  // cy
  output->cy = input->cy;
  // k1
  output->k1 = input->k1;
  // k2
  output->k2 = input->k2;
  // k3
  output->k3 = input->k3;
  // k4
  output->k4 = input->k4;
  // rms
  output->rms = input->rms;
  // fov
  output->fov = input->fov;
  // calibration_temperature
  output->calibration_temperature = input->calibration_temperature;
  // p1
  output->p1 = input->p1;
  // p2
  output->p2 = input->p2;
  // production_date
  if (!rosidl_runtime_c__String__copy(
      &(input->production_date), &(output->production_date)))
  {
    return false;
  }
  return true;
}

clpe_ros_msgs__msg__ClpeCameraInfo *
clpe_ros_msgs__msg__ClpeCameraInfo__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clpe_ros_msgs__msg__ClpeCameraInfo * msg = (clpe_ros_msgs__msg__ClpeCameraInfo *)allocator.allocate(sizeof(clpe_ros_msgs__msg__ClpeCameraInfo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(clpe_ros_msgs__msg__ClpeCameraInfo));
  bool success = clpe_ros_msgs__msg__ClpeCameraInfo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
clpe_ros_msgs__msg__ClpeCameraInfo__destroy(clpe_ros_msgs__msg__ClpeCameraInfo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    clpe_ros_msgs__msg__ClpeCameraInfo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__init(clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clpe_ros_msgs__msg__ClpeCameraInfo * data = NULL;

  if (size) {
    data = (clpe_ros_msgs__msg__ClpeCameraInfo *)allocator.zero_allocate(size, sizeof(clpe_ros_msgs__msg__ClpeCameraInfo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = clpe_ros_msgs__msg__ClpeCameraInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        clpe_ros_msgs__msg__ClpeCameraInfo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__fini(clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      clpe_ros_msgs__msg__ClpeCameraInfo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

clpe_ros_msgs__msg__ClpeCameraInfo__Sequence *
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * array = (clpe_ros_msgs__msg__ClpeCameraInfo__Sequence *)allocator.allocate(sizeof(clpe_ros_msgs__msg__ClpeCameraInfo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__destroy(clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__are_equal(const clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * lhs, const clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!clpe_ros_msgs__msg__ClpeCameraInfo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__copy(
  const clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * input,
  clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(clpe_ros_msgs__msg__ClpeCameraInfo);
    clpe_ros_msgs__msg__ClpeCameraInfo * data =
      (clpe_ros_msgs__msg__ClpeCameraInfo *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!clpe_ros_msgs__msg__ClpeCameraInfo__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          clpe_ros_msgs__msg__ClpeCameraInfo__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!clpe_ros_msgs__msg__ClpeCameraInfo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
