// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from clpe_ros_msgs:msg/ClpeCameraInfo.idl
// generated code does not contain a copyright notice

#ifndef CLPE_ROS_MSGS__MSG__DETAIL__CLPE_CAMERA_INFO__FUNCTIONS_H_
#define CLPE_ROS_MSGS__MSG__DETAIL__CLPE_CAMERA_INFO__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "clpe_ros_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "clpe_ros_msgs/msg/detail/clpe_camera_info__struct.h"

/// Initialize msg/ClpeCameraInfo message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * clpe_ros_msgs__msg__ClpeCameraInfo
 * )) before or use
 * clpe_ros_msgs__msg__ClpeCameraInfo__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
bool
clpe_ros_msgs__msg__ClpeCameraInfo__init(clpe_ros_msgs__msg__ClpeCameraInfo * msg);

/// Finalize msg/ClpeCameraInfo message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
void
clpe_ros_msgs__msg__ClpeCameraInfo__fini(clpe_ros_msgs__msg__ClpeCameraInfo * msg);

/// Create msg/ClpeCameraInfo message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * clpe_ros_msgs__msg__ClpeCameraInfo__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
clpe_ros_msgs__msg__ClpeCameraInfo *
clpe_ros_msgs__msg__ClpeCameraInfo__create();

/// Destroy msg/ClpeCameraInfo message.
/**
 * It calls
 * clpe_ros_msgs__msg__ClpeCameraInfo__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
void
clpe_ros_msgs__msg__ClpeCameraInfo__destroy(clpe_ros_msgs__msg__ClpeCameraInfo * msg);

/// Check for msg/ClpeCameraInfo message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
bool
clpe_ros_msgs__msg__ClpeCameraInfo__are_equal(const clpe_ros_msgs__msg__ClpeCameraInfo * lhs, const clpe_ros_msgs__msg__ClpeCameraInfo * rhs);

/// Copy a msg/ClpeCameraInfo message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
bool
clpe_ros_msgs__msg__ClpeCameraInfo__copy(
  const clpe_ros_msgs__msg__ClpeCameraInfo * input,
  clpe_ros_msgs__msg__ClpeCameraInfo * output);

/// Initialize array of msg/ClpeCameraInfo messages.
/**
 * It allocates the memory for the number of elements and calls
 * clpe_ros_msgs__msg__ClpeCameraInfo__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
bool
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__init(clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * array, size_t size);

/// Finalize array of msg/ClpeCameraInfo messages.
/**
 * It calls
 * clpe_ros_msgs__msg__ClpeCameraInfo__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
void
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__fini(clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * array);

/// Create array of msg/ClpeCameraInfo messages.
/**
 * It allocates the memory for the array and calls
 * clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence *
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__create(size_t size);

/// Destroy array of msg/ClpeCameraInfo messages.
/**
 * It calls
 * clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
void
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__destroy(clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * array);

/// Check for msg/ClpeCameraInfo message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
bool
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__are_equal(const clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * lhs, const clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * rhs);

/// Copy an array of msg/ClpeCameraInfo messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_clpe_ros_msgs
bool
clpe_ros_msgs__msg__ClpeCameraInfo__Sequence__copy(
  const clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * input,
  clpe_ros_msgs__msg__ClpeCameraInfo__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // CLPE_ROS_MSGS__MSG__DETAIL__CLPE_CAMERA_INFO__FUNCTIONS_H_
